#include <windows.h>
#include "LocalError2.h"
#include "ErrorShell.h"

int WINAPI DllMain( HINSTANCE hInstance, DWORD dwReason, PVOID pvReserved )
{
	return TRUE;
}

EXPORT int	CALLBACK ReportStdError( HKEY hAppKey,	 int  errNumber,
									 int  errType, 	 UINT delay, 	 
									 char * pszMsg,	 char * pszCaptions,
									 char * pszTitle )
{
	ERRORMSG2 errMsg2;
	char szMsg[10240];					// allocate local buffers
	char szCaptions[1024];
	char szTitle[1024];
	char * pTemp;						// temporary pointer
	UINT i;

	memset( szMsg, '\0', 10240 );		// zero string buffers
	memset( szCaptions, '\0', 1024 );
	memset( szTitle, '\0', 1024 );

	//=== copy incoming buffers to local allocations ===
	pTemp = pszMsg;
	for( i=0; i<strlen( pszMsg ); i++, pTemp++ )
		szMsg[i] = *pTemp;

	pTemp = pszCaptions;
	for( i=0; i<strlen( pszCaptions ); i++, pTemp++ )
		szCaptions[i] = *pTemp;

	pTemp = pszTitle;
	for( i=0; i<strlen( pszTitle ); i++, pTemp++ )
		szTitle[i] = *pTemp;

	errMsg2.pszErrorString = &szMsg[0];			// address of local buffer
	errMsg2.nErrorCode = errNumber;
	errMsg2.ErrorType = (ERRORTYPE) errType;
	return ReportErrorStd2( errMsg2, hAppKey, delay, szCaptions, szTitle );
}

EXPORT void CALLBACK ReportPopup( UINT	 delay,	 WORD  wAlign, 
								  int	 xPos,   int   yPos,
								  char * pszMsg )
{
	ERRORMSG2	errMsg2;
	POINT		point;
	char		szMsg[1024];		// allocate local buffer
	char *		pTemp;				// temporary buffer
	UINT		i;

	pTemp = pszMsg;
	for( i=0; i<strlen( pszMsg ); i++, pTemp++ )
		szMsg[i] = *pTemp;

	errMsg2.pszErrorString = &szMsg[0];		// address of local buffer
	errMsg2.nErrorCode = 0;
	errMsg2.ErrorType = POPUP_MESSAGE;
	point.x = xPos;
	point.y = yPos;
	ReportPopup2( errMsg2, delay, point, wAlign );
}
